function  [HMAT,Hd,Icell,Cont]=Mat(PMUPLACES,Ybus)
n=14;       % The number of busbars
MaxSig=6;   %Max number of measured signals by a PMU
H=zeros(n,MaxSig,n);
Icell=zeros(n,MaxSig-1,2);

% H(i,:,:) contains the measurement equations for bus i.
% H(i,j,:) contains jth measurement equation for bus i. 
% H(i,j,k) determines the dependence of jth measurement coefficient on kth
% bus in the ith bus equation
for ii=1:n
    H(ii,1,ii)=1;
    Cont(ii)=1;
end
%Building matrix H in Z=Hx+v
IEEE14BusData;
[m,k]=size(BRANCH);
for ii=1:m
    [k]=BRANCH(ii,:);
    Cont(k(1))=Cont(k(1))+1;
    Cont(k(2))=Cont(k(2))+1;
    H(k(1),Cont(k(1)),k(1))=Ybus(k(1),k(2))+Ybus(k(1),k(1));
    H(k(1),Cont(k(1)),k(2))=-Ybus(k(1),k(2));
    H(k(2),Cont(k(2)),k(2))=Ybus(k(2),k(1))+Ybus(k(2),k(2));    
    H(k(2),Cont(k(2)),k(1))=-Ybus(k(2),k(1));
    Icell(k(1),Cont(k(1))-1,1:2)=k;
    Icell(k(2),Cont(k(2))-1,1:2)=[k(2),k(1)];
end
   
HMAT=[];
for ii=1:length(PMUPLACES)
    PMU=PMUPLACES(ii);
    Temp=[];
    for jj=1:Cont(PMU)
        for kk=1:n
            Temp(jj,kk)=H(PMU,jj,kk);
        end
    end
    HMAT=[HMAT;Temp];
end

Hr=real(HMAT);
Hm=imag(HMAT);
Hd=[Hr -Hm;Hm Hr];
end

